package com.fossgalaxy.games.ggj2017;

import com.fossgalaxy.games.ggj2017.drones.DroneBuildAction;
import com.fossgalaxy.games.rts.GameState;
import com.fossgalaxy.games.rts.entity.Entity;
import com.fossgalaxy.games.rts.entity.EntityType;
import com.fossgalaxy.games.rts.entity.Resource;
import com.fossgalaxy.games.rts.entity.ResourceType;
import com.fossgalaxy.object.annotations.ObjectDef;
import org.codetome.hexameter.core.api.CubeCoordinate;

public class BuildOnResourceAction extends DroneBuildAction {

    private ResourceType typeOn;

    // Can build type only on places containing typeOn
    @ObjectDef("BuildOnResource")
    public BuildOnResourceAction(EntityType type, ResourceType typeOn) {
        super(type);
        this.typeOn = typeOn;
    }

    @Override
    public boolean isPossible(Entity entity, GameState s, CubeCoordinate co) {
        if(!super.isPossible(entity, s, co)) return false;

        // Check resource of correct type is present
        Resource resourceAt = s.getResourceAt(co);
        if(resourceAt == null){
            return false;
        }

        return (resourceAt.getType().equals(typeOn));
    }
}
