package com.fossgalaxy.games.ggj2017.drones;

import java.awt.Graphics2D;
import com.fossgalaxy.object.annotations.ObjectDef;
import org.codetome.hexameter.core.api.CubeCoordinate;
import com.fossgalaxy.games.rts.GameState;
import com.fossgalaxy.games.rts.actions.MinesAction;
import com.fossgalaxy.games.rts.entity.Entity;
import com.fossgalaxy.games.rts.entity.ResourceType;

public class DroneMineAction extends MinesAction {

	@ObjectDef("DroneMine")
	public DroneMineAction(ResourceType type, int val) {
		super(type, val);
	}
	
	@Override
	public void renderHints(Graphics2D g, GameState s, Entity actor) {
		if (actor == null || !DroneUtils.rangeHint(g, actor, s)) {
			return;
		}
		
		super.renderHints(g, s, actor);		
	}
	
	@Override
	public boolean isPossible(Entity entity, GameState s, CubeCoordinate co) {
		if (!DroneUtils.isZoneOfControl(s, entity)) {
			return false;
		}
		
		return super.isPossible(entity, s, co);
	}
	
}
