package com.fossgalaxy.games.ggj2017.drones;

import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.util.Collection;

import org.codetome.hexameter.core.api.Hexagon;

import com.fossgalaxy.games.rts.GameState;
import com.fossgalaxy.games.rts.entity.Entity;
import com.fossgalaxy.games.rts.entity.HexagonTile;
import com.fossgalaxy.games.rts.io.SpriteRegistry;

public class DroneUtils {
	
	public static boolean rangeHint(Graphics g, Entity actor, GameState s) {
		if (!isZoneOfControl(s, actor)) {
			SpriteRegistry sr = SpriteRegistry.INSTANCE;
			BufferedImage img = sr.getImage("ui/no-signal");
			
			Hexagon<HexagonTile> ht = s.cube2hex(actor.getPos());
			
			g.drawImage(img, (int)ht.getCenterX() - 25, (int)ht.getCenterY() - 25, 50, 50, null);
			
			return false;
		}
		
		return true;
	}

	public static boolean isZoneOfControl(GameState state, Entity curr) {
		Collection<Entity> entities = state.getOwnedEntities(curr.getOwner());
		
		for (Entity e : entities) {
			Integer zoneDistance = e.getType().getProperty("controlSignal");
			if (zoneDistance != null) {
				int distance = state.getDistance(e.getPos(), curr.getPos());
				if (distance <= zoneDistance) {
					return true;
				}
			}
		}
		
		return false;
	}
	
}
